/*
function flatten(obj)
{
    var a = [];
    if (obj instanceof Array) {
        return obj.map(function(e) {return flatten(e) ;});
    } else {
        return obj
    }
};
*/

function to_2hexstr(b)
{
    return ('0'+ b.toString(16)).substr(-2).toUpperCase();
};

function hex_line(data, address, record_type)
{
    var sum = 0;
    sum += data.length;
    sum += (address >> 8);
    sum += (address & 0xff);
    sum += record_type;

    var line = '';
    line += ':';
    line += to_2hexstr(data.length);
    line += to_2hexstr(address >> 8);
    line += to_2hexstr(address & 0xff);
    line += to_2hexstr(record_type);
    for (var i = 0; i < data.length; i++) {
        sum = (sum + data[i]);
        line += to_2hexstr(data[i]);
    }
    line += to_2hexstr((~sum + 1)&0xff);  // Checksum
    line +="\r\n";
    return line;
}

function hex_output(keymaps) {
    var output = '';
    var bytes = [];

    // TODO: address
    
    // TODO: refine
    // flatten keymaps into one dimension array
    [].concat.apply([], [].concat.apply([], keymaps)).forEach(function(e) {
        bytes.push(e);
        if (bytes.length == 16) {
            output += hex_line(bytes, 0x0123, 0x05);
            console.log(bytes);
            bytes.length = 0;
        }
    });
    if (bytes.length > 0) {
        console.log(bytes);
    }
    return output;
};

function source_output(keymaps) {
    var output = '';
    // fn actions
    output += "/*\n";
    output += " * Keymap for PFU HHKB Pro\n";
    output += " *   generated by tmk keymap editor\n";
    output += " */\n";
    output += "#include <stdint.h>\n";
    output += "#include <stdbool.h>\n";
    output += "#include <avr/pgmspace.h>\n";
    output += "#include \"keycode.h\"\n";
    output += "#include \"action.h\"\n";
    output += "#include \"action_macro.h\"\n";
    output += "#include \"keymap.h\"\n\n";

    output += "static const uint16_t PROGMEM fn_actions[] = {\n";
    output += "    [0]  = ACTION_LAYER_MOMENTARY(0), \n";
    output += "    [1]  = ACTION_LAYER_MOMENTARY(1), \n";
    output += "    [2]  = ACTION_LAYER_MOMENTARY(2), \n";
    output += "    [3]  = ACTION_LAYER_MOMENTARY(3), \n";
    output += "    [4]  = ACTION_LAYER_TOGGLE(0), \n";
    output += "    [5]  = ACTION_LAYER_TOGGLE(1), \n";
    output += "    [6]  = ACTION_LAYER_TOGGLE(2), \n";
    output += "    [7]  = ACTION_LAYER_TOGGLE(3), \n";
    output += "    [8]  = ACTION_LAYER_TAP_TOGGLE(0), \n";
    output += "    [9]  = ACTION_LAYER_TAP_TOGGLE(1), \n";
    output += "    [10] = ACTION_LAYER_TAP_TOGGLE(2), \n";
    output += "    [11] = ACTION_LAYER_TAP_TOGGLE(3), \n";
    output += "};\n\n";

    // keymaps
    output += 'static const uint8_t PROGMEM keymaps[][';
    output += keymaps[0].length;         // row
    output += '][';
    output += keymaps[0][0].length;      // col
    output += "] = {\n";
    for (var i in keymaps) {
        output += "    {\n";
        for (var j in keymaps[i]) {
            output += "        { ";
            for (var k in keymaps[i][j]) {
                output += '0x' + ('0' + keymaps[i][j][k].toString(16)).substr(-2);
                output += ',';
            }
            output += " },\n";
        }
        output += "    },\n";
    }
    output += "};\n\n";
    output += "/* translates key to keycode */\n";
    output += "uint8_t keymap_key_to_keycode(uint8_t layer, key_t key)\n";
    output += "{\n";
    output += "    return pgm_read_byte(&keymaps[(layer)][(key.row)][(key.col)]);\n";
    output += "}\n";
    output += "\n";
    output += "/* translates Fn index to action */\n";
    output += "action_t keymap_fn_to_action(uint8_t keycode)\n";
    output += "{\n";
    output += "    action_t action;\n";
    output += "    if (FN_INDEX(keycode) < sizeof(fn_actions) / sizeof(fn_actions[0])) {\n";
    output += "        action.code = pgm_read_word(&fn_actions[FN_INDEX(keycode)]);\n";
    output += "    } else {\n";
    output += "        action.code = ACTION_NO;\n";
    output += "    }\n";
    output += "    return action;\n";
    output += "}\n";
    return output;
};

var id_code = {
    'act-no': 0,
    'act-roll-over': 1,
    'act-post-fail': 2,
    'act-undefined': 3,
    'act-a': 4,
    'act-b': 5,
    'act-c': 6,
    'act-d': 7,
    'act-e': 8,
    'act-f': 9,
    'act-g': 10,
    'act-h': 11,
    'act-i': 12,
    'act-j': 13,
    'act-k': 14,
    'act-l': 15,
    'act-m': 16,
    'act-n': 17,
    'act-o': 18,
    'act-p': 19,
    'act-q': 20,
    'act-r': 21,
    'act-s': 22,
    'act-t': 23,
    'act-u': 24,
    'act-v': 25,
    'act-w': 26,
    'act-x': 27,
    'act-y': 28,
    'act-z': 29,
    'act-1': 30,
    'act-2': 31,
    'act-3': 32,
    'act-4': 33,
    'act-5': 34,
    'act-6': 35,
    'act-7': 36,
    'act-8': 37,
    'act-9': 38,
    'act-0': 39,
    'act-enter': 40,
    'act-escape': 41,
    'act-bspace': 42,
    'act-tab': 43,
    'act-space': 44,
    'act-minus': 45,
    'act-equal': 46,
    'act-lbracket': 47,
    'act-rbracket': 48,
    'act-bslash': 49,
    'act-nonus-hash': 50,
    'act-scolon': 51,
    'act-quote': 52,
    'act-grave': 53,
    'act-comma': 54,
    'act-dot': 55,
    'act-slash': 56,
    'act-capslock': 57,
    'act-f1': 58,
    'act-f2': 59,
    'act-f3': 60,
    'act-f4': 61,
    'act-f5': 62,
    'act-f6': 63,
    'act-f7': 64,
    'act-f8': 65,
    'act-f9': 66,
    'act-f10': 67,
    'act-f11': 68,
    'act-f12': 69,
    'act-pscreen': 70,
    'act-scrolllock': 71,
    'act-pause': 72,
    'act-insert': 73,
    'act-home': 74,
    'act-pgup': 75,
    'act-delete': 76,
    'act-end': 77,
    'act-pgdown': 78,
    'act-right': 79,
    'act-left': 80,
    'act-down': 81,
    'act-up': 82,
    'act-numlock': 83,
    'act-kp-slash': 84,
    'act-kp-asterisk': 85,
    'act-kp-minus': 86,
    'act-kp-plus': 87,
    'act-kp-enter': 88,
    'act-kp-1': 89,
    'act-kp-2': 90,
    'act-kp-3': 91,
    'act-kp-4': 92,
    'act-kp-5': 93,
    'act-kp-6': 94,
    'act-kp-7': 95,
    'act-kp-8': 96,
    'act-kp-9': 97,
    'act-kp-0': 98,
    'act-kp-dot': 99,
    'act-nonus-bslash': 100,
    'act-application': 101,
    'act-power': 102,
    'act-kp-equal': 103,
    'act-f13': 104,
    'act-f14': 105,
    'act-f15': 106,
    'act-f16': 107,
    'act-f17': 108,
    'act-f18': 109,
    'act-f19': 110,
    'act-f20': 111,
    'act-f21': 112,
    'act-f22': 113,
    'act-f23': 114,
    'act-f24': 115,
    'act-execute': 116,
    'act-help': 117,
    'act-menu': 118,
    'act-select': 119,
    'act-stop': 120,
    'act-again': 121,
    'act-undo': 122,
    'act-cut': 123,
    'act-copy': 124,
    'act-paste': 125,
    'act-find': 126,
    'act--mute': 127,
    'act--volup': 128,
    'act--voldown': 129,
    'act-locking-caps': 130,
    'act-locking-num': 131,
    'act-locking-scroll': 132,
    'act-kp-comma': 133,
    'act-kp-equal-as400': 134,
    'act-int1': 135,
    'act-int2': 136,
    'act-int3': 137,
    'act-int4': 138,
    'act-int5': 139,
    'act-int6': 140,
    'act-int7': 141,
    'act-int8': 142,
    'act-int9': 143,
    'act-lang1': 144,
    'act-lang2': 145,
    'act-lang3': 146,
    'act-lang4': 147,
    'act-lang5': 148,
    'act-lang6': 149,
    'act-lang7': 150,
    'act-lang8': 151,
    'act-lang9': 152,
    'act-alt-erase': 153,
    'act-sysreq': 154,
    'act-cancel': 155,
    'act-clear': 156,
    'act-prior': 157,
    'act-return': 158,
    'act-separator': 159,
    'act-out': 160,
    'act-oper': 161,
    'act-clear-again': 162,
    'act-crsel': 163,
    'act-exsel': 164,
    'act-reserved-165': 165,
    'act-reserved-166': 166,
    'act-reserved-167': 167,
    'act-reserved-168': 168,
    'act-reserved-169': 169,
    'act-reserved-170': 170,
    'act-reserved-171': 171,
    'act-reserved-172': 172,
    'act-reserved-173': 173,
    'act-reserved-174': 174,
    'act-reserved-175': 175,
    'act-kp-00': 176,
    'act-kp-000': 177,
    'act-thousands-separator': 178,
    'act-decimal-separator': 179,
    'act-currency-unit': 180,
    'act-currency-sub-unit': 181,
    'act-kp-lparen': 182,
    'act-kp-rparen': 183,
    'act-kp-lcbracket': 184,
    'act-kp-rcbracket': 185,
    'act-kp-tab': 186,
    'act-kp-bspace': 187,
    'act-kp-a': 188,
    'act-kp-b': 189,
    'act-kp-c': 190,
    'act-kp-d': 191,
    'act-kp-e': 192,
    'act-kp-f': 193,
    'act-kp-xor': 194,
    'act-kp-hat': 195,
    'act-kp-perc': 196,
    'act-kp-lt': 197,
    'act-kp-gt': 198,
    'act-kp-and': 199,
    'act-kp-lazyand': 200,
    'act-kp-or': 201,
    'act-kp-lazyor': 202,
    'act-kp-colon': 203,
    'act-kp-hash': 204,
    'act-kp-space': 205,
    'act-kp-atmark': 206,
    'act-kp-exclamation': 207,
    'act-kp-mem-store': 208,
    'act-kp-mem-recall': 209,
    'act-kp-mem-clear': 210,
    'act-kp-mem-add': 211,
    'act-kp-mem-sub': 212,
    'act-kp-mem-mul': 213,
    'act-kp-mem-div': 214,
    'act-kp-plus-minus': 215,
    'act-kp-clear': 216,
    'act-kp-clear-entry': 217,
    'act-kp-binary': 218,
    'act-kp-octal': 219,
    'act-kp-decimal': 220,
    'act-kp-hexadecimal': 221,
    'act-reserved-222': 222,
    'act-reserved-223': 223,
    'act-lctrl': 224,
    'act-lshift': 225,
    'act-lalt': 226,
    'act-lgui': 227,
    'act-rctrl': 228,
    'act-rshift': 229,
    'act-ralt': 230,
    'act-rgui': 231,
};

/* keycode to display */
var code_display = [
    // {id, name(text), description(tooltip)}
    {id: 'NO  ',                        name: 'NO',                          desc: 'No action'},
    {id: 'TRNS',                        name: 'TRNS',                        desc: 'Transparent'},
    {id: 'POST_FAIL',                   name: 'POST_FAIL',                   desc: 'POST_FAIL'},
    {id: 'UNDEFINED',                   name: 'UNDEFINED',                   desc: 'UNDEFINED'},
    {id: 'A',                           name: 'A',                           desc: 'A'},
    {id: 'B',                           name: 'B',                           desc: 'B'},
    {id: 'C',                           name: 'C',                           desc: 'C'},
    {id: 'D',                           name: 'D',                           desc: 'D'},
    {id: 'E',                           name: 'E',                           desc: 'E'},
    {id: 'F',                           name: 'F',                           desc: 'F'},
    {id: 'G',                           name: 'G',                           desc: 'G'},
    {id: 'H',                           name: 'H',                           desc: 'H'},
    {id: 'I',                           name: 'I',                           desc: 'I'},
    {id: 'J',                           name: 'J',                           desc: 'J'},
    {id: 'K',                           name: 'K',                           desc: 'K'},
    {id: 'L',                           name: 'L',                           desc: 'L'},
    {id: 'M',                           name: 'M',                           desc: 'M'},
    {id: 'N',                           name: 'N',                           desc: 'N'},
    {id: 'O',                           name: 'O',                           desc: 'O'},
    {id: 'P',                           name: 'P',                           desc: 'P'},
    {id: 'Q',                           name: 'Q',                           desc: 'Q'},
    {id: 'R',                           name: 'R',                           desc: 'R'},
    {id: 'S',                           name: 'S',                           desc: 'S'},
    {id: 'T',                           name: 'T',                           desc: 'T'},
    {id: 'U',                           name: 'U',                           desc: 'U'},
    {id: 'V',                           name: 'V',                           desc: 'V'},
    {id: 'W',                           name: 'W',                           desc: 'W'},
    {id: 'X',                           name: 'X',                           desc: 'X'},
    {id: 'Y',                           name: 'Y',                           desc: 'Y'},
    {id: 'Z',                           name: 'Z',                           desc: 'Z'},
    {id: '1',                           name: '1',                           desc: '1'},
    {id: '2',                           name: '2',                           desc: '2'},
    {id: '3',                           name: '3',                           desc: '3'},
    {id: '4',                           name: '4',                           desc: '4'},
    {id: '5',                           name: '5',                           desc: '5'},
    {id: '6',                           name: '6',                           desc: '6'},
    {id: '7',                           name: '7',                           desc: '7'},
    {id: '8',                           name: '8',                           desc: '8'},
    {id: '9',                           name: '9',                           desc: '9'},
    {id: '0',                           name: '0',                           desc: '0'},
    {id: 'ENT',                         name: 'Enter',                       desc: 'ENTER'},
    {id: 'ESC',                         name: 'Esc',                         desc: 'Escape'},
    {id: 'BSPC',                        name: 'Back Space',                  desc: 'Back Space'},
    {id: 'TAB',                         name: 'Tab',                         desc: 'Tab'},
    {id: 'SPC',                         name: 'Space',                       desc: 'Space'},
    {id: 'MINS',                        name: '-',                           desc: 'MINUS'},
    {id: 'EQL',                         name: '=',                           desc: 'EQUAL'},
    {id: 'LBRC',                        name: '[',                           desc: 'Left Bracket'},
    {id: 'RBRC',                        name: ']',                           desc: 'Right Bracket'},
    {id: 'BSLS',                        name: "\\",                          desc: 'Backslash'},
    {id: 'NUHS',                        name: 'ISO #',                       desc: 'Non-US Hash'},
    {id: 'SCLN',                        name: ';',                           desc: 'Semicolon'},
    {id: 'QUOT',                        name: "'",                           desc: 'Quote'},
    {id: 'GRV ',                        name: '`',                           desc: 'Grave'},
    {id: 'COMM',                        name: ',',                           desc: 'Comma'},
    {id: 'DOT ',                        name: '.',                           desc: 'Dot'},
    {id: 'SLSH',                        name: '/',                           desc: 'Slash'},
    {id: 'CAPS',                        name: 'Caps Lock',                   desc: 'Need this? Sure? :)'},
    {id: 'F1  ',                        name: 'F1',                          desc: 'F1'},
    {id: 'F2  ',                        name: 'F2',                          desc: 'F2'},
    {id: 'F3  ',                        name: 'F3',                          desc: 'F3'},
    {id: 'F4  ',                        name: 'F4',                          desc: 'F4'},
    {id: 'F5  ',                        name: 'F5',                          desc: 'F5'},
    {id: 'F6  ',                        name: 'F6',                          desc: 'F6'},
    {id: 'F7  ',                        name: 'F7',                          desc: 'F7'},
    {id: 'F8  ',                        name: 'F8',                          desc: 'F8'},
    {id: 'F9  ',                        name: 'F9',                          desc: 'F9'},
    {id: 'F10 ',                        name: 'F10',                         desc: 'F10'},
    {id: 'F11 ',                        name: 'F11',                         desc: 'F11'},
    {id: 'F12 ',                        name: 'F12',                         desc: 'F12'},
    {id: 'PSCR',                        name: 'Print Screen',                desc: 'Print Screen'},
    {id: 'SLCK',                        name: 'Scroll Lock',                 desc: 'Scroll Lock'},
    {id: 'PAUS',                        name: 'Pause',                       desc: 'Pause'},
    {id: 'INS ',                        name: 'Insert',                      desc: 'Insert'},
    {id: 'HOME',                        name: 'Home',                        desc: 'Home'},
    {id: 'PGUP',                        name: 'Page Up',                     desc: 'Page Up'},
    {id: 'DEL ',                        name: 'Delete',                      desc: 'Delete'},
    {id: 'END ',                        name: 'END',                         desc: 'End'},
    {id: 'PGDN',                        name: 'Page Down',                   desc: 'Page Down'},
    {id: 'RGHT',                        name: '\u2192',                      desc: 'Right'},
    {id: 'LEFT',                        name: '\u2190',                      desc: 'Left'},
    {id: 'DOWN',                        name: '\u2193',                      desc: 'Down'},
    {id: 'UP  ',                        name: '\u2191',                      desc: 'Up'},
    {id: 'NLCK',                        name: 'Num Lock',                     desc: 'Num Lock'},
    {id: 'PSLS',                        name: 'P/',                          desc: 'Keypad Slash'},
    {id: 'PAST',                        name: 'P*',                          desc: 'Keypad Asterisk'},
    {id: 'PMNS',                        name: 'P-',                          desc: 'Keypad Minus'},
    {id: 'PPLS',                        name: 'P+',                          desc: 'Keypad Plus'},
    {id: 'PENT',                        name: 'P\u21A9',                      desc: 'Keypad Enter'},
    {id: 'P1  ',                        name: 'P1',                          desc: 'Keypad 1'},
    {id: 'P2  ',                        name: 'P2',                          desc: 'Keypad 2'},
    {id: 'P3  ',                        name: 'P3',                          desc: 'Keypad 3'},
    {id: 'P4  ',                        name: 'P4',                          desc: 'Keypad 4'},
    {id: 'P5  ',                        name: 'P5',                          desc: 'Keypad 5'},
    {id: 'P6  ',                        name: 'P6',                          desc: 'Keypad 6'},
    {id: 'P7  ',                        name: 'P7',                          desc: 'Keypad 7'},
    {id: 'P8  ',                        name: 'P8',                          desc: 'Keypad 8'},
    {id: 'P9  ',                        name: 'P9',                          desc: 'Keypad 9'},
    {id: 'P0  ',                        name: 'P0',                          desc: 'Keypad 0'},
    {id: 'PDOT',                        name: 'P.',                          desc: 'Keypad Dot'},
    {id: 'NUBS',                        name: 'ISO \\',                      desc: 'Non-US Backslash'},
    {id: 'APP ',                        name: 'Application',                 desc: 'Application'},
    {id: 'POWER',                       name: '_Power',                      desc: 'Power(Not work on Windows)'},
    {id: 'PEQL',                        name: 'P=',                          desc: 'Keymapd Equal'},
    {id: 'F13 ',                        name: 'F13',                         desc: 'F13'},
    {id: 'F14 ',                        name: 'F14',                         desc: 'F14'},
    {id: 'F15 ',                        name: 'F15',                         desc: 'F15'},
    {id: 'F16 ',                        name: 'F16',                         desc: 'F16'},
    {id: 'F17 ',                        name: 'F17',                         desc: 'F17'},
    {id: 'F18 ',                        name: 'F18',                         desc: 'F18'},
    {id: 'F19 ',                        name: 'F19',                         desc: 'F19'},
    {id: 'F20 ',                        name: 'F20',                         desc: 'F20'},
    {id: 'F21 ',                        name: 'F21',                         desc: 'F21'},
    {id: 'F22 ',                        name: 'F22',                         desc: 'F22'},
    {id: 'F23 ',                        name: 'F23',                         desc: 'F23'},
    {id: 'F24 ',                        name: 'F24',                         desc: 'F24'},
    {id: 'EXECUTE',                     name: 'EXECUTE',                     desc: 'EXECUTE'},
    {id: 'HELP',                        name: 'HELP',                        desc: 'HELP'},
    {id: 'MENU',                        name: 'MENU',                        desc: 'MENU'},
    {id: 'SELECT',                      name: 'SELECT',                      desc: 'SELECT'},
    {id: 'STOP',                        name: 'STOP',                        desc: 'STOP'},
    {id: 'AGAIN',                       name: 'AGAIN',                       desc: 'AGAIN'},
    {id: 'UNDO',                        name: 'UNDO',                        desc: 'UNDO'},
    {id: 'CUT',                         name: 'CUT',                         desc: 'CUT'},
    {id: 'COPY',                        name: 'COPY',                        desc: 'COPY'},
    {id: 'PASTE',                       name: 'PASTE',                       desc: 'PASTE'},
    {id: 'FIND',                        name: 'FIND',                        desc: 'FIND'},
    {id: '_MUTE',                       name: '_MUTE',                       desc: '_MUTE(Not work on Windows)'},
    {id: '_VOLUP',                      name: '_VOLUP',                      desc: '_VOLUP(Not work on Windows)'},
    {id: '_VOLDOWN',                    name: '_VOLDOWN',                    desc: '_VOLDOWN(Not work on Windows)'},
    {id: 'LCAP',                        name: 'Locking Caps Lock',           desc: 'Locking Caps Lock'},
    {id: 'LNUM',                        name: 'Locking Num Lock',            desc: 'Locking Num Lock'},
    {id: 'LSCR',                        name: 'Locking Scroll Lock',         desc: 'Locking Scroll Lock'},
    {id: 'PCMM',                        name: 'P,',                          desc: 'Keypad Comma'},
    {id: 'KP_EQUAL_AS400',              name: 'P= (AS400)',                  desc: 'Keypad Equal (AS400)'},
    {id: 'INT1',                        name: '\u308D',                      desc: 'Japanese RO'},
    {id: 'INT2',                        name: '\u3072\u3089\u304c\u306a',    desc: 'Japanese Hiragana'},
    {id: 'INT3',                        name: '\uffe5',                      desc: 'Japanese Yen'},
    {id: 'INT4',                        name: '\u5909\u63db',                desc: 'Japanese Henkan'},
    {id: 'INT5',                        name: '\u7121\u5909\u63db',                desc: 'Japanese Muhenkan'},
    {id: 'INT6',                        name: 'INT6',                        desc: 'INT6'},
    {id: 'INT7',                        name: 'INT7',                        desc: 'INT7'},
    {id: 'INT8',                        name: 'INT8',                        desc: 'INT8'},
    {id: 'INT9',                        name: 'INT9',                        desc: 'INT9'},
    {id: 'LANG1',                       name: 'LANG1',                       desc: 'LANG1'},
    {id: 'LANG2',                       name: 'LANG2',                       desc: 'LANG2'},
    {id: 'LANG3',                       name: 'LANG3',                       desc: 'LANG3'},
    {id: 'LANG4',                       name: 'LANG4',                       desc: 'LANG4'},
    {id: 'LANG5',                       name: 'LANG5',                       desc: 'LANG5'},
    {id: 'LANG6',                       name: 'LANG6',                       desc: 'LANG6'},
    {id: 'LANG7',                       name: 'LANG7',                       desc: 'LANG7'},
    {id: 'LANG8',                       name: 'LANG8',                       desc: 'LANG8'},
    {id: 'LANG9',                       name: 'LANG9',                       desc: 'LANG9'},
    {id: 'ALT_ERASE',                   name: 'ALT_ERASE',                   desc: 'ALT_ERASE'},
    {id: 'SYSREQ',                      name: 'SYSREQ',                      desc: 'SYSREQ'},
    {id: 'CANCEL',                      name: 'CANCEL',                      desc: 'CANCEL'},
    {id: 'CLEAR',                       name: 'CLEAR',                       desc: 'CLEAR'},
    {id: 'PRIOR',                       name: 'PRIOR',                       desc: 'PRIOR'},
    {id: 'RETURN',                      name: 'RETURN',                      desc: 'RETURN'},
    {id: 'SEPARATOR',                   name: 'SEPARATOR',                   desc: 'SEPARATOR'},
    {id: 'OUT',                         name: 'OUT',                         desc: 'OUT'},
    {id: 'OPER',                        name: 'OPER',                        desc: 'OPER'},
    {id: 'CLEAR_AGAIN',                 name: 'CLEAR_AGAIN',                 desc: 'CLEAR_AGAIN'},
    {id: 'CRSEL',                       name: 'CRSEL',                       desc: 'CRSEL'},
    {id: 'EXSEL',                       name: 'EXSEL',                       desc: 'EXSEL'},

    /* Special codes A5-DF */
    /* System & Media key */
    {id: 'PWR ',                        name: 'Sys Power',                   desc: 'System Power'},
    {id: 'SLEP',                        name: 'Sys Sleep',                   desc: 'System Sleep'},
    {id: 'WAKE',                        name: 'Sys Wake',                    desc: 'System Wake'},
    {id: 'MUTE',                        name: 'Mute',                        desc: 'Audio Mute'},
    {id: 'VOLU',                        name: 'Vol Up',                      desc: 'Audio Vol Up'},
    {id: 'VOLD',                        name: 'Vol Down',                    desc: 'Audio Vol Down'},
    {id: 'MNXT',                        name: 'Next Track',                  desc: 'Next Track'},
    {id: 'MPRV',                        name: 'Prev Track',                  desc: 'Previous Track'},
    {id: 'MSTP',                        name: 'Stop',                        desc: 'Media Stop'},
    {id: 'MPLY',                        name: 'Play Pause',                  desc: 'Play Pause'},
    {id: 'MSEL',                        name: 'Select',                      desc: 'Media Select'},
    {id: 'EJCT',                        name: 'Eject',                       desc: 'Media Eject'},
    {id: 'MAIL',                        name: 'Mail',                        desc: 'Mail'},
    {id: 'CALC',                        name: 'Calc',                        desc: 'Calculator'},
    {id: 'MYCM',                        name: 'My Computer',                 desc: 'My Computer'},
    {id: 'WSCH',                        name: 'WWW Search',                  desc: 'WWW Search'},
    {id: 'WHOM',                        name: 'WWW Home',                    desc: 'WWW Home'},
    {id: 'WBAK',                        name: 'WWW Back',                    desc: 'WWW Back'},
    {id: 'WFWD',                        name: 'WWW Forward',                 desc: 'WWW Forward'},
    {id: 'WSTP',                        name: 'WWW Stop',                    desc: 'WWW Stop'},
    {id: 'WREF',                        name: 'WWW Refresh',                 desc: 'WWW Refresh'},
    {id: 'WFAV',                        name: 'WWW Favorites',               desc: 'WWW Favorites'},
    {id: 'RESERVED-187',                name: 'RESERVED-187',                desc: 'RESERVED-187'},
    {id: 'RESERVED-188',                name: 'RESERVED-188',                desc: 'RESERVED-188'},
    {id: 'RESERVED-189',                name: 'RESERVED-189',                desc: 'RESERVED-189'},
    {id: 'RESERVED-190',                name: 'RESERVED-190',                desc: 'RESERVED-190'},
    {id: 'RESERVED-191',                name: 'RESERVED-191',                desc: 'RESERVED-191'},
    /* Fn key */
    {id: 'FN0 ',                        name: 'L0',                          desc: 'Change to Layer 0(Momentary) '},
    {id: 'FN1 ',                        name: 'L1',                          desc: 'Change to Layer 1(Momentary) '},
    {id: 'FN2 ',                        name: 'L2',                          desc: 'Change to Layer 2(Momentary) '},
    {id: 'FN3 ',                        name: 'L3',                          desc: 'Change to Layer 3(Momentary) '},
    {id: 'FN4 ',                        name: 'T0',                          desc: 'Change to Layer 0(Toggle) '},
    {id: 'FN5 ',                        name: 'T1',                          desc: 'Change to Layer 1(Toggle) '},
    {id: 'FN6 ',                        name: 'T2',                          desc: 'Change to Layer 2(Toggle) '},
    {id: 'FN7 ',                        name: 'T3',                          desc: 'Change to Layer 3(Toggle) '},
    {id: 'FN8 ',                        name: 'TL0',                         desc: 'Change to Layer 0(Momentary with Tap Toggle) '},
    {id: 'FN9 ',                        name: 'TL1',                         desc: 'Change to Layer 1(Momentary with Tap Toggle) '},
    {id: 'FN10',                        name: 'TL2',                         desc: 'Change to Layer 2(Momentary with Tap Toggle) '},
    {id: 'FN11',                        name: 'TL3',                         desc: 'Change to Layer 3(Momentary with Tap Toggle) '},

/*
    {id: 'FN0 ',                        name: 'FN0 ',                        desc: 'FN0 '},
    {id: 'FN1 ',                        name: 'FN1 ',                        desc: 'FN1 '},
    {id: 'FN2 ',                        name: 'FN2 ',                        desc: 'FN2 '},
    {id: 'FN3 ',                        name: 'FN3 ',                        desc: 'FN3 '},
    {id: 'FN4 ',                        name: 'FN4 ',                        desc: 'FN4 '},
    {id: 'FN5 ',                        name: 'FN5 ',                        desc: 'FN5 '},
    {id: 'FN6 ',                        name: 'FN6 ',                        desc: 'FN6 '},
    {id: 'FN7 ',                        name: 'FN7 ',                        desc: 'FN7 '},
    {id: 'FN8 ',                        name: 'FN8 ',                        desc: 'FN8 '},
    {id: 'FN9 ',                        name: 'FN9 ',                        desc: 'FN9 '},
    {id: 'FN10',                        name: 'FN10',                        desc: 'FN10'},
    {id: 'FN11',                        name: 'FN11',                        desc: 'FN11'},
*/
    {id: 'FN12',                        name: 'FN12',                        desc: 'FN12'},
    {id: 'FN13',                        name: 'FN13',                        desc: 'FN13'},
    {id: 'FN14',                        name: 'FN14',                        desc: 'FN14'},
    {id: 'FN15',                        name: 'FN15',                        desc: 'FN15'},
    {id: 'FN16',                        name: 'FN16',                        desc: 'FN16'},
    {id: 'FN17',                        name: 'FN17',                        desc: 'FN17'},
    {id: 'FN18',                        name: 'FN18',                        desc: 'FN18'},
    {id: 'FN19',                        name: 'FN19',                        desc: 'FN19'},
    {id: 'FN20',                        name: 'FN20',                        desc: 'FN20'},
    {id: 'FN21',                        name: 'FN21',                        desc: 'FN21'},
    {id: 'FN22',                        name: 'FN22',                        desc: 'FN22'},
    {id: 'FN23',                        name: 'FN23',                        desc: 'FN23'},
    {id: 'FN24',                        name: 'FN24',                        desc: 'FN24'},
    {id: 'FN25',                        name: 'FN25',                        desc: 'FN25'},
    {id: 'FN26',                        name: 'FN26',                        desc: 'FN26'},
    {id: 'FN27',                        name: 'FN27',                        desc: 'FN27'},
    {id: 'FN28',                        name: 'FN28',                        desc: 'FN28'},
    {id: 'FN29',                        name: 'FN29',                        desc: 'FN29'},
    {id: 'FN30',                        name: 'FN30',                        desc: 'FN30'},
    {id: 'FN31',                        name: 'FN31',                        desc: 'FN31'},

/* Standeard codes for 16bit Action
    {id: 'RESERVED-165',                name: 'RESERVED-165',                desc: 'RESERVED-165'},
    {id: 'RESERVED-166',                name: 'RESERVED-166',                desc: 'RESERVED-166'},
    {id: 'RESERVED-167',                name: 'RESERVED-167',                desc: 'RESERVED-167'},
    {id: 'RESERVED-168',                name: 'RESERVED-168',                desc: 'RESERVED-168'},
    {id: 'RESERVED-169',                name: 'RESERVED-169',                desc: 'RESERVED-169'},
    {id: 'RESERVED-170',                name: 'RESERVED-170',                desc: 'RESERVED-170'},
    {id: 'RESERVED-171',                name: 'RESERVED-171',                desc: 'RESERVED-171'},
    {id: 'RESERVED-172',                name: 'RESERVED-172',                desc: 'RESERVED-172'},
    {id: 'RESERVED-173',                name: 'RESERVED-173',                desc: 'RESERVED-173'},
    {id: 'RESERVED-174',                name: 'RESERVED-174',                desc: 'RESERVED-174'},
    {id: 'RESERVED-175',                name: 'RESERVED-175',                desc: 'RESERVED-175'},

    {id: 'KP_00',                       name: 'KP_00',                       desc: 'KP_00'},
    {id: 'KP_000',                      name: 'KP_000',                      desc: 'KP_000'},
    {id: 'THOUSANDS_SEPARATOR',         name: 'THOUSANDS_SEPARATOR',         desc: 'THOUSANDS_SEPARATOR'},
    {id: 'DECIMAL_SEPARATOR',           name: 'DECIMAL_SEPARATOR',           desc: 'DECIMAL_SEPARATOR'},
    {id: 'CURRENCY_UNIT',               name: 'CURRENCY_UNIT',               desc: 'CURRENCY_UNIT'},
    {id: 'CURRENCY_SUB_UNIT',           name: 'CURRENCY_SUB_UNIT',           desc: 'CURRENCY_SUB_UNIT'},
    {id: 'KP_LPAREN',                   name: 'KP_LPAREN',                   desc: 'KP_LPAREN'},
    {id: 'KP_RPAREN',                   name: 'KP_RPAREN',                   desc: 'KP_RPAREN'},
    {id: 'KP_LCBRACKET',                name: 'KP_LCBRACKET',                desc: 'KP_LCBRACKET'},
    {id: 'KP_RCBRACKET',                name: 'KP_RCBRACKET',                desc: 'KP_RCBRACKET'},
    {id: 'KP_TAB',                      name: 'KP_TAB',                      desc: 'KP_TAB'},
    {id: 'KP_BSPACE',                   name: 'KP_BSPACE',                   desc: 'KP_BSPACE'},
    {id: 'KP_A',                        name: 'KP_A',                        desc: 'KP_A'},
    {id: 'KP_B',                        name: 'KP_B',                        desc: 'KP_B'},
    {id: 'KP_C',                        name: 'KP_C',                        desc: 'KP_C'},
    {id: 'KP_D',                        name: 'KP_D',                        desc: 'KP_D'},
    {id: 'KP_E',                        name: 'KP_E',                        desc: 'KP_E'},
    {id: 'KP_F',                        name: 'KP_F',                        desc: 'KP_F'},
    {id: 'KP_XOR',                      name: 'KP_XOR',                      desc: 'KP_XOR'},
    {id: 'KP_HAT',                      name: 'KP_HAT',                      desc: 'KP_HAT'},
    {id: 'KP_PERC',                     name: 'KP_PERC',                     desc: 'KP_PERC'},
    {id: 'KP_LT',                       name: 'KP_LT',                       desc: 'KP_LT'},
    {id: 'KP_GT',                       name: 'KP_GT',                       desc: 'KP_GT'},
    {id: 'KP_AND',                      name: 'KP_AND',                      desc: 'KP_AND'},
    {id: 'KP_LAZYAND',                  name: 'KP_LAZYAND',                  desc: 'KP_LAZYAND'},
    {id: 'KP_OR',                       name: 'KP_OR',                       desc: 'KP_OR'},
    {id: 'KP_LAZYOR',                   name: 'KP_LAZYOR',                   desc: 'KP_LAZYOR'},
    {id: 'KP_COLON',                    name: 'KP_COLON',                    desc: 'KP_COLON'},
    {id: 'KP_HASH',                     name: 'KP_HASH',                     desc: 'KP_HASH'},
    {id: 'KP_SPACE',                    name: 'KP_SPACE',                    desc: 'KP_SPACE'},
    {id: 'KP_ATMARK',                   name: 'KP_ATMARK',                   desc: 'KP_ATMARK'},
    {id: 'KP_EXCLAMATION',              name: 'KP_EXCLAMATION',              desc: 'KP_EXCLAMATION'},
    {id: 'KP_MEM_STORE',                name: 'KP_MEM_STORE',                desc: 'KP_MEM_STORE'},
    {id: 'KP_MEM_RECALL',               name: 'KP_MEM_RECALL',               desc: 'KP_MEM_RECALL'},
    {id: 'KP_MEM_CLEAR',                name: 'KP_MEM_CLEAR',                desc: 'KP_MEM_CLEAR'},
    {id: 'KP_MEM_ADD',                  name: 'KP_MEM_ADD',                  desc: 'KP_MEM_ADD'},
    {id: 'KP_MEM_SUB',                  name: 'KP_MEM_SUB',                  desc: 'KP_MEM_SUB'},
    {id: 'KP_MEM_MUL',                  name: 'KP_MEM_MUL',                  desc: 'KP_MEM_MUL'},
    {id: 'KP_MEM_DIV',                  name: 'KP_MEM_DIV',                  desc: 'KP_MEM_DIV'},
    {id: 'KP_PLUS_MINUS',               name: 'KP_PLUS_MINUS',               desc: 'KP_PLUS_MINUS'},
    {id: 'KP_CLEAR',                    name: 'KP_CLEAR',                    desc: 'KP_CLEAR'},
    {id: 'KP_CLEAR_ENTRY',              name: 'KP_CLEAR_ENTRY',              desc: 'KP_CLEAR_ENTRY'},
    {id: 'KP_BINARY',                   name: 'KP_BINARY',                   desc: 'KP_BINARY'},
    {id: 'KP_OCTAL',                    name: 'KP_OCTAL',                    desc: 'KP_OCTAL'},
    {id: 'KP_DECIMAL',                  name: 'KP_DECIMAL',                  desc: 'KP_DECIMAL'},
    {id: 'KP_HEXADECIMAL',              name: 'KP_HEXADECIMAL',              desc: 'KP_HEXADECIMAL'},
    {id: 'RESERVED-222',                name: 'RESERVED-222',                desc: 'RESERVED-222'},
    {id: 'RESERVED-223',                name: 'RESERVED-223',                desc: 'RESERVED-223'},
*/

    {id: 'LCTL',                        name: 'LCtrl',                       desc: 'Left Control'},
    {id: 'LSFT',                        name: 'LShift',                      desc: 'Left Shift'},
    {id: 'LALT',                        name: 'LAlt',                        desc: 'Left Alt(\u2325)'},
    {id: 'LGUI',                        name: 'LGui',                        desc: 'Left Windows(\u2318)'},
    {id: 'RCTL',                        name: 'RCtrl',                       desc: 'Right Control'},
    {id: 'RSFT',                        name: 'RShift',                      desc: 'Right Shift'},
    {id: 'RALT',                        name: 'RAlt',                        desc: 'Right Alt(\u2325)'},
    {id: 'RGUI',                        name: 'RGui',                        desc: 'Right Windows(\u2318)'},

    /* Special codes E8-FF */
    {id: 'RESERVED-232',                name: 'RESERVED-232',                desc: 'RESERVED-232'},
    {id: 'RESERVED-233',                name: 'RESERVED-233',                desc: 'RESERVED-233'},
    {id: 'RESERVED-234',                name: 'RESERVED-234',                desc: 'RESERVED-234'},
    {id: 'RESERVED-235',                name: 'RESERVED-235',                desc: 'RESERVED-235'},
    {id: 'RESERVED-236',                name: 'RESERVED-236',                desc: 'RESERVED-236'},
    {id: 'RESERVED-237',                name: 'RESERVED-237',                desc: 'RESERVED-237'},
    {id: 'RESERVED-238',                name: 'RESERVED-238',                desc: 'RESERVED-238'},
    {id: 'RESERVED-239',                name: 'RESERVED-239',                desc: 'RESERVED-239'},
    /* Mousekey */
    {id: 'MS_U',                        name: 'MS_UP',                       desc: 'MS_UP'},
    {id: 'MS_D',                        name: 'MS_DOWN',                     desc: 'MS_DOWN'},
    {id: 'MS_L',                        name: 'MS_LEFT',                     desc: 'MS_LEFT'},
    {id: 'MS_R',                        name: 'MS_RIGHT',                    desc: 'MS_RIGHT'},
    {id: 'BTN1',                        name: 'MS_BTN1',                     desc: 'MS_BTN1'},
    {id: 'BTN2',                        name: 'MS_BTN2',                     desc: 'MS_BTN2'},
    {id: 'BTN3',                        name: 'MS_BTN3',                     desc: 'MS_BTN3'},
    {id: 'BTN4',                        name: 'MS_BTN4',                     desc: 'MS_BTN4'},
    {id: 'BTN5',                        name: 'MS_BTN5',                     desc: 'MS_BTN5'},
    {id: 'WH_U',                        name: 'MS_WH_UP',                    desc: 'MS_WH_UP'},
    {id: 'WH_D',                        name: 'MS_WH_DOWN',                  desc: 'MS_WH_DOWN'},
    {id: 'WH_L',                        name: 'MS_WH_LEFT',                  desc: 'MS_WH_LEFT'},
    {id: 'WH_R',                        name: 'MS_WH_RIGHT',                 desc: 'MS_WH_RIGHT'},
    {id: 'ACL0',                        name: 'MS_ACCEL0',                   desc: 'MS_ACCEL0'},
    {id: 'ACL1',                        name: 'MS_ACCEL1',                   desc: 'MS_ACCEL1'},
    {id: 'ACL2',                        name: 'MS_ACCEL2',                   desc: 'MS_ACCEL2'},
];
